﻿Public Class ProxyTabControl
    Inherits TabControl

    Public ReadOnly Property ProxyConfigs As List(Of ProxyConfig)

    Public Sub New(ByVal proxyConfigs As List(Of ProxyConfig))
        Me.ProxyConfigs = proxyConfigs
        CreateProxyTabs()
    End Sub

    Public Sub GoToUrl(ByVal url As String)
        For Each tabPage As TabPage In TabPages
            Dim proxyTabPage As ProxyTabPage = TryCast(tabPage, ProxyTabPage)

            If proxyTabPage IsNot Nothing Then
                proxyTabPage.GoToUrl(url)
            End If
        Next
    End Sub

    Private Sub CreateProxyTabs()
        Dim tabWithoutProxy As ProxyTabPage = New ProxyTabPage(Nothing)
        TabPages.Add(tabWithoutProxy)

        For Each proxyConfig As ProxyConfig In ProxyConfigs
            Dim tabWithProxy As ProxyTabPage = New ProxyTabPage(proxyConfig)
            TabPages.Add(tabWithProxy)
        Next
    End Sub

    Public Sub DisposeTabs()
        For Each tabPage As TabPage In TabPages
            Dim proxyTabPage As ProxyTabPage = TryCast(tabPage, ProxyTabPage)

            If proxyTabPage IsNot Nothing Then
                proxyTabPage.DisposeBrowser()
            End If
        Next
    End Sub
End Class